/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Maths.xs. Do not edit this file, edit Maths.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Faster/Maths.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2021 -- leonerd@leonerd.org.uk
 */
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define HAVE_PERL_VERSION(R, V, S) \
    (PERL_REVISION > (R) || (PERL_REVISION == (R) && (PERL_VERSION > (V) || (PERL_VERSION == (V) && (PERL_SUBVERSION >= (S))))))

#if HAVE_PERL_VERSION(5,28,0)
#  define GET_UNOP_AUX_item_pv(aux)    ((aux).pv)
#  define SET_UNOP_AUX_item_pv(aux,v)  ((aux).pv = (v))
#else
#  define GET_UNOP_AUX_item_pv(aux)    INT2PTR(char *, (aux).uv)
#  define SET_UNOP_AUX_item_pv(aux,v)  ((aux).uv = PTR2UV(v))
#endif

static XOP xop_multimath;
static OP *pp_multimath(pTHX)
{
  dSP;
  dTARGET;
  UNOP_AUX_item *aux = cUNOP_AUX->op_aux;

  char *prog = GET_UNOP_AUX_item_pv(aux[0]) + 1; /* skip leading '(' */
  U32 ntmps = PL_op->op_private;

  U32 tmpi = 1;
  NV accum;

  U32 auxi = 1 + ntmps;

  switch(*(prog++)) {
    case 'p':
      accum = SvNV_nomg(PAD_SV(aux[auxi].pad_offset));
      auxi++;
      break;

    case 'c':
      accum = SvNV_nomg(aux[auxi].sv);
      auxi++;
      break;

    default:
      croak("ARGH: initial prog instruction");
  }

  while(*prog) {
    char op = *(prog++);
    switch(op) {
      case '+':
      case '-':
      case '*':
      case '/':
      {
        NV rhs;
        switch(*(prog++)) {
          case 'p':
            rhs = SvNV_nomg(PAD_SV(aux[auxi].pad_offset));
            auxi++;
            break;
          case 'c':
            rhs = SvNV_nomg(aux[auxi].sv);
            auxi++;
            break;
          case ')':
            rhs = accum;
            tmpi--;
            accum = SvNV_nomg(PAD_SV(aux[tmpi].pad_offset));
            break;
          default:
            croak("ARGH MULTIMATH arg %c\n", prog[-1]);
        }

        switch(op) {
          case '+':
            accum += rhs;
            break;
          case '-':
            accum -= rhs;
            break;
          case '*':
            accum *= rhs;
            break;
          case '/':
            accum /= rhs;
            break;
        }
        break;
      }

      case '(':
      {
        NV val;
        switch(*(prog++)) {
          case 'p':
            val = SvNV_nomg(PAD_SV(aux[auxi].pad_offset));
            auxi++;
            break;
          case 'c':
            val = SvNV_nomg(aux[auxi].sv);
            auxi++;
            break;
        }
        sv_setnv(PAD_SV(aux[tmpi].pad_offset), accum);
        tmpi++;
        accum = val;
        break;
      }

      default:
        croak("TODO: MULTIMATH %c\n", op);
    }
  }

  EXTEND(SP, 1);
  PUSHn(accum);
  RETURN;
}

#define optimize_maths(start, final)  MY_optimize_maths(aTHX_ start, final)
static OP *MY_optimize_maths(pTHX_ OP *start, OP *final)
{
  OP *o;

  /* Phase 1: just count the number of aux items we need
   * We'll need one for every constant or padix
   * Also count the maximum stack height
   */
  U32 nitems = 1; /* aux[0] is the program */
  U32 height = 0, maxheight = 0;

  for(o = start; o; o = o->op_next) {
    switch(o->op_type) {
      case OP_CONST:
      case OP_PADSV:
        nitems++;
        height++;
        break;

      case OP_ADD:
      case OP_SUBTRACT:
      case OP_MULTIPLY:
      case OP_DIVIDE:
        height--;
        break;
    }

    if(height > maxheight)
      maxheight = height;

    if(o == final)
      break;
  }

  U32 ntmps = maxheight - 1;

  UNOP_AUX_item *aux;
  Newx(aux, nitems + ntmps, UNOP_AUX_item);

  SV *prog = newSV(0);
  sv_setpvs(prog, "");

  U32 tmpi = 1;
  U32 auxi = 1 + ntmps;

  /* Phase 2: collect up the constants and padices, build the program string */
  char lastarg = ')';
  char operator;
  for(o = start; o; o = o->op_next) {
    switch(o->op_type) {
      case OP_CONST:
        if(lastarg != ')')
          sv_catpvf(prog, "(%c", lastarg);
        lastarg = 'c';
        aux[auxi++].sv = SvREFCNT_inc(cSVOPo->op_sv);
        break;

      case OP_PADSV:
        if(lastarg != ')')
          sv_catpvf(prog, "(%c", lastarg);
        lastarg = 'p';
        aux[auxi++].pad_offset = o->op_targ;
        break;

      case OP_ADD:
        operator = '+';
        goto do_BINOP;
      case OP_SUBTRACT:
        operator = '-';
        goto do_BINOP;
      case OP_MULTIPLY:
        operator = '*';
        goto do_BINOP;
      case OP_DIVIDE:
        operator = '/';
        goto do_BINOP;

do_BINOP:
        sv_catpvf(prog, "%c%c", operator, lastarg);
        lastarg = ')';

        /* Steal a padtmp because that won't be using it */
        if(tmpi <= ntmps)
          aux[tmpi++].pad_offset = o->op_targ;
        break;


      default:
        croak("ARGH unsure how to optimize this op\n");
    }

    if(o == final)
      break;
  }

  if(SvPVX(prog)[0] != '(')
    croak("ARGH: expected prog to begin (");

  /* Steal the buffer */
  SET_UNOP_AUX_item_pv(aux[0], SvPVX(prog)); SvLEN(prog) = 0;
  SvREFCNT_dec(prog);

  OP *retop = newUNOP_AUX(OP_CUSTOM, 0, NULL, aux);
  retop->op_ppaddr = &pp_multimath;
  retop->op_private = ntmps;
  retop->op_targ = final->op_targ;

  return retop;
}

static void rpeep_for_fastermaths(pTHX_ OP *o, bool init_enabled);
static void rpeep_for_fastermaths(pTHX_ OP *o, bool init_enabled)
{
  bool enabled = init_enabled;

  OP *prevo = NULL;

  /* In some cases (e.g.  while(1) { ... } ) the ->op_next chain actually
   * forms a closed loop. In order to detect this loop and break out we'll
   * advance the `slowo` pointer half as fast as o. If o is ever equal to
   * slowo then we have reached a cycle and should stop
   */
  OP *slowo = NULL;
  int slowotick = 0;

  while(o && o != slowo) {
    if(o->op_type == OP_NEXTSTATE) {
      SV *sv = cop_hints_fetch_pvs(cCOPo, "Faster::Maths/faster", 0);
      enabled = sv && sv != &PL_sv_placeholder && SvTRUE(sv);
      goto next_o;
    }
    if(!enabled)
      goto next_o;

    /* There are no BASEOP mathsy ops, so any optimizable sequence necessarily
     * starts with an argument
     */
    switch(o->op_type) {
      case OP_CONST:
      case OP_PADSV:
        break;

      case OP_OR:
      case OP_AND:
      case OP_DOR:
#if HAVE_PERL_VERSION(5,32,0)
      case OP_CMPCHAIN_AND:
#endif
      case OP_COND_EXPR:
      case OP_MAPWHILE:
      case OP_ANDASSIGN:
      case OP_ORASSIGN:
      case OP_DORASSIGN:
      case OP_RANGE:
      case OP_ONCE:
#if HAVE_PERL_VERSION(5,26,0)
      case OP_ARGDEFELEM:
#endif
        /* Optimize on the righthand side of `or` / `and` operators and other.
         * similar cases. This might catch more things than perl's own
         * recursion inside because simple expressions don't begin with an
         * OP_NEXTSTATE
         */
        if(cLOGOPo->op_other && cLOGOPo->op_other->op_type != OP_NEXTSTATE)
          rpeep_for_fastermaths(aTHX_ cLOGOPo->op_other, enabled);
        goto next_o;

      default:
        goto next_o;
    }

    /* Find a sequence of mathsy args/ops we can optimize */
    OP *final = NULL;       /* the final op in the optimizable chain */
    U32 final_opcount = 0;  /* total number of operations we found until final */
    {
      U32 opcount = 0;
      U32 height = 0; /* running height of the stack */

      OP *scout;
      for(scout = o; scout; scout = scout->op_next) {
        switch(scout->op_type) {
          /* OPs that push 1 argument */
          case OP_CONST:
          case OP_PADSV:
            height++;
            break;

          /* BINOPs that consume 2, push 1 */
          case OP_ADD:
          case OP_SUBTRACT:
          case OP_MULTIPLY:
          case OP_DIVIDE:
            if(height < 2)
              /* We never had enough arguments, meaning any of the initial
               * ones for this op must have been of a kind we don't recognise
               * Abort and go to the next outer loop; we'll pick up an
               * optimizable inner sub-chain again later
               */
              goto next_o;

            opcount++;
            height--;
            if(height == 1) {
              final = scout;
              final_opcount = opcount;
            }
            break;

          default:
            if(!final)
              /* We never finished on an op that would give us a height of 1,
               * which means we probably took too many initial argument ops.
               * Abort now and go to the next outer loop; we'll pick up an
               * optimizable inner sub-chain again later
               */
              goto next_o;

            goto done_scout;
        }
      }
done_scout:
      ;
    }

    /* If we found fewer than 2 operations there's no point optimizing them */
    if(final_opcount < 2)
      goto next_o;

    /* At this point we now know that the sequence o to final consists of
     * optimizable ops yielding a single final scalar answer.
     */
    OP *newo = optimize_maths(o, final);

    newo->op_next = final->op_next;
    if(prevo)
      prevo->op_next = o = newo;
    else {
      /* we optimized starting at the very first op in this chain */
      o->op_targ = o->op_type;
      o->op_type = OP_NULL;
      o->op_next = newo;

      o = newo;
    }

next_o:
    if(!slowo)
      slowo = o;
    else if((slowotick++) % 2)
      slowo = slowo->op_next;

    prevo = o;
    o = o->op_next;
  }
}

static void (*next_rpeepp)(pTHX_ OP *o);

static void
my_rpeepp(pTHX_ OP *o)
{
  if(!o)
    return;

  (*next_rpeepp)(aTHX_ o);

  rpeep_for_fastermaths(aTHX_ o, FALSE);
}

#line 406 "lib/Faster/Maths.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 550 "lib/Faster/Maths.c"
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Faster__Maths); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Faster__Maths)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif


    /* Initialisation Section */

#line 399 "lib/Faster/Maths.xs"
  /* TODO: find the correct wrapper function for this */
  next_rpeepp = PL_rpeepp;
  PL_rpeepp = &my_rpeepp;

  XopENTRY_set(&xop_multimath, xop_name, "multimath");
  XopENTRY_set(&xop_multimath, xop_desc,
    "combined maths operations");
  XopENTRY_set(&xop_multimath, xop_class, OA_UNOP_AUX);
  Perl_custom_op_register(aTHX_ &pp_multimath, &xop_multimath);

#line 586 "lib/Faster/Maths.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
